// KeyboardMap.cpp
// (c) 2003 exeal

#include "StdAfx.h"
#include "KeyboardMap.h"
#include "..\Manah\File.h"
using Alpha::CKeyboardMap;
using Alpha::KeyModifier;

const wchar_t* CKeyboardMap::m_arrKeyName[0x0100] = {	// L[̖O (蓖ĕs\ȃL[ null)
	/* 0x00 */	0,	0,	0,	L"Esc",	L"NbN",	0,	0,	0,
				L"BackSpace",	L"Tab",	0,	0,	L"Del",	L"Enter",	0,	0,
				0,	0,	0,	0,	0,	0,	0,	0,
				L"Esc",	0,	0,	0,	0,	0,	0,	0,
	/* 0x20 */	L"Space",	L"PageUp",	L"PageDown",	L"End",	L"Home",	L"",	L"",	L"",
				L"",	0,	0,	0,	0,	0,	0,	0,
				L"0",	L"1",	L"2",	L"3",	L"4",	L"5",	L"6",	L"7",
				L"8",	L"9",	0,	0,	0,	0,	0,	0,
	/* 0x40 */	0,	L"A",	L"B",	L"C",	L"D",	L"E",	L"F",	L"G",
				L"H",	L"I",	L"J",	L"K",	L"L",	L"M",	L"N",	L"O",
				L"P",	L"Q",	L"R",	L"S",	L"T",	L"U",	L"V",	L"W",
				L"X",	L"Y",	L"Z",	0,	0,	0,	0,	0,
	/* 0x60 */	0,	0,	0,	0,	0,	0,	0,	0,
				0,	0,	L"*",	L"+",	L"|",	L"-",	L".",	L"/",
				L"F1",	L"F2",	L"F3",	L"F4",	L"F5",	L"F6",	L"F7",	L"F8",
				L"F9",	L"F10",	L"F11",	L"F12",	L"F13",	L"F14",	L"F15",	L"F16",
	/* 0x80 */	L"F17",	L"F18",	L"F19",	L"F20",	L"F21",	L"F22",	L"F23",	L"F24",
				0,	0,	0,	0,	0,	0,	0,	0,
				0,	0,	0,	0,	0,	0,	0,	0,
				0,	0,	0,	0,	0,	0,	0,	0,
	/* 0xA0 */	0,	0,	0,	0,	0,	0,	0,	0,
				0,	0,	0,	0,	0,	0,	0,	0,
				0,	0,	0,	0,	0,	0,	0,	0,
				0,	0,	L":",	L";",	L",",	0,	0,	0,
	/* 0xC0 */	L"@",	0,	0,	0,	0,	0,	0,	0,
				0,	0,	0,	0,	0,	0,	0,	0,
				0,	0,	0,	0,	0,	0,	0,	0,
				0,	0,	0,	L"[",	L"\\",	L"]",	L"^",	0,
	/* 0xE0 */	0,	0,	0,	0,	0,	0,	0,	0,
				0,	0,	0,	0,	0,	0,	0,	0,
				0,	0,	0,	0,	0,	0,	0,	0,
				0,	0,	0,	0,	0,	0,	0,	0
};


// CKeyboardMap class implementation
/////////////////////////////////////////////////////////////////////////////

CKeyboardMap::CKeyboardMap() {
	Reset();
	m_bDirty = false;
}

/**
 *	݂̃IuWFNg̏ԂANZ[^e[u쐬AԂ
 *	@return	쐬ꂽANZ[^e[uBĂяo폜KvB
 *			R}h1o^ĂȂƂ null
 */
HACCEL CKeyboardMap::CreateAcceleratorTable() const {
	if(m_cCommands == 0)
		return 0;

	HACCEL	hAccel = 0;
	LPACCEL	pAccels = new ACCEL[m_cCommands];

	int		c = 0;
	for(short i = 0; i < 0x0100; ++i) {
		for(int j = 0; j < 8; ++j) {
			if(m_arrCommands[j][i] != 0) {
				(pAccels + c)->cmd = m_arrCommands[j][i];
				(pAccels + c)->key = i;
				(pAccels + c)->fVirt = FNOINVERT | FVIRTKEY;
				if(toBoolean(j & KM_ALT))
					(pAccels + c)->fVirt |= FALT;
				if(toBoolean(j & KM_CTRL))
					(pAccels + c)->fVirt |= FCONTROL;
				if(toBoolean(j & KM_SHIFT))
					(pAccels + c)->fVirt |= FSHIFT;
				++c;
			}
		}
	}
	assert(c == m_cCommands);
	hAccel = ::CreateAcceleratorTable(pAccels, m_cCommands);

	delete[] pAccels;
	return hAccel;
}

/**
 *	L[R}h ID 擾
 *	@param sVKey			zL[
 *	@param km				CL[
 *	@return					蓖ĂĂR}h IDB蓖ĂĂȂƂ0
 *	@exception out_of_range	<var>sVKey</var> sȂƂX[
 */
int CKeyboardMap::GetCommandID(short sVKey, KeyModifier km) const throw(out_of_range) {
	if(sVKey >= 0x0100)
		throw out_of_range("The first argument is invalid as virutal key code.");
	return m_arrCommands[km][sVKey];
}

/**
 *	蓖ĂĂL[ƏCL[Ԃ
 *	@param nCommand	R}h ID
 *	@param sVKey	zL[
 *	@param km		CL[
 *	@return			R}ho^Ăΐ^
 */
bool CKeyboardMap::GetKeyBind(int nCommand, short& sVKey, KeyModifier& km) const {
	for(short i = 0; i < 0x0100; ++i) {
		for(BYTE j = 0; j < 8; ++j) {
			if(m_arrCommands[j][i] == nCommand) {
				sVKey = i;
				km = static_cast<KeyModifier>(j);
				return true;
			}
		}
	}
	return false;
}

/**
 *	L[̖OԂ
 *	@param sVKey			zL[
 *	@return					L[BΉL[ꍇ null
 *	@exception out_of_range	<var>sVKey</var> sȂƂX[
 */
const wchar_t* CKeyboardMap::GetKeyName(short sVKey) throw(out_of_range) {
	if(sVKey >= 0x100)
		throw out_of_range("The first argument is invalid as virutal key code.");
	return m_arrKeyName[sVKey];
}

/**
 *	R}hɊ蓖ĂĂL[̕\擾
 *	@param nCommand	R}h
 *	@return			"Ctrl+N" Ȃǂ̕\Bo^ĂȂ΋󕶎
 */
wstring CKeyboardMap::GetKeyString(int nCommand) const {
	wstring	str;

	for(short i = 0; i < 0x0100; ++i) {
		for(BYTE j = 0; j < 8; ++j) {
			if(m_arrCommands[j][i] == nCommand) {
				if(toBoolean(j & KM_CTRL))
					str += L"Ctrl+";
				if(toBoolean(j & KM_SHIFT))
					str += L"Shift+";
				if(toBoolean(j & KM_ALT))
					str += L"Alt+";
				str += m_arrKeyName[i];
				return str;
			}
		}
	}
	return str;
}

///	@see	ISerializable::IsDirty
bool CKeyboardMap::IsDirty() const {
	return m_bDirty;
}

///	@see	ISerializable::Load
bool CKeyboardMap::Load(const wchar_t* pwszPathName) {
	assert(pwszPathName != 0);

	Reset();

	try {
		CFile	oFile(pwszPathName, CFile::modeRead);
		int		nCommand;
		short	key;
		BYTE	modifier;

		while(true) {
			if(sizeof(int) != oFile.Read(&nCommand, sizeof(int)))
				break;
			if(sizeof(short) != oFile.Read(&key, sizeof(short)))
				break;
			if(sizeof(BYTE) != oFile.Read(&modifier, sizeof(BYTE)))
				break;
			SetOneCommand(key, static_cast<KeyModifier>(modifier), nCommand);
		}
		oFile.Close();
	} catch(CFileException& /*e*/) {
		return false;
	}

	m_bDirty = false;
	return true;
}

///	o^Sĉ
void CKeyboardMap::Reset() {
	m_bDirty = true;
	m_cCommands = 0;
	memset(m_arrCommands, 0, sizeof(int) * 0x0100 * 8);
}

///	@see	ISerializable::Save
bool CKeyboardMap::Save(const wchar_t* pwszPathName) {
	assert(pwszPathName != 0);

	try {
		CFile	oFile(pwszPathName, CFile::modeWrite | CFile::modeCreate | CFile::shareExclusive);
		for(short key = 0x0000; key < 0x0100; ++key) {
			for(BYTE modifier = 0; modifier < 8; ++modifier) {
				if(m_arrCommands[modifier][key] != 0) {	// R}h
					oFile.Write(&m_arrCommands[modifier][key], sizeof(int));
					oFile.Write(&key, sizeof(short));
					oFile.Write(&modifier, sizeof(BYTE));
				}
			}
		}
		oFile.Close();
	} catch(CFileException& /*e*/) {
		return false;
	}

	m_bDirty = false;
	return true;
}

/**
 *	1̃R}ho^
 *	@param sVKey		zL[
 *	@param kbm			CL[
 *	@param nCommand		R}h ID
 *	@throw out_of_range	<var>sVKey</var> 256ȏ̂ƂX[
 */
void CKeyboardMap::SetOneCommand(short sVKey, KeyModifier kbm, int nCommand) throw(out_of_range) {
	if(sVKey >= 0x0100)
		throw out_of_range("The first argument is invalid as virutal key code.");
	if(nCommand != 0 && m_arrCommands[kbm][sVKey] == 0)
		++m_cCommands;
	else if(nCommand == 0 && m_arrCommands[kbm][sVKey] != 0)
		--m_cCommands;
	m_arrCommands[kbm][sVKey] = nCommand;
	m_bDirty = true;
}

/* [EOF] */